<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: HttpClient.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: HttpClient.js</h1>






    <section>
        <article>
            <pre class="prettyprint source linenums"><code>import fetch from 'cross-fetch';
import esSixPromise from 'es6-promise';

// import HttpStatus from 'http-status-codes';

esSixPromise.polyfill();

/**
 * This class is responsible to make the authentication, token validation and sending request
 *
 * @returns {Promise} Returns a new Promise object.
 */
export default class HttpClient {
  constructor (configuration) {
    this.apiBaseURL = configuration.apiBaseURL;
    this.apiKey = configuration.apiKey;
  }

  /**
   * This function is responsible to get the request configuration in which the headers are set. If a Get its requested just return a
   *request configuration without headers.
   *
   * @param {string} method - Http method (GET | POST | PATCH | DELETE)
   * @returns {Promise} Returns a new  object.
   */
  getRequestConfiguration (method, params) {
    const headers = {
      'Content-Type': 'application/json',
      'X-DreamFactory-API-Key': this.apiKey,
    };

    const requestConfiguration = {
      headers,
      method,
    };

    if (method !== 'GET') {
      requestConfiguration.body = JSON.stringify(params);
    }

    return requestConfiguration;
  }

  /**
   * This function is responsible to send a request to an endpoint after get the request configuration.
   *
   * @param {string} url - endpoint uri
   * @param {string} method - Http method (GET | POST | PATCH | DELETE)
   * @param {params} params - Json Object
   * @returns {Promise} Returns a new Promise object which can be resolved or rejected if its not a 200 response.
   */
  sendRequest (url, method, params = {}) {
    const requestConfiguration = this.getRequestConfiguration(method, params);

    let fullURL = this.apiBaseURL + url;

    const paramsKeys = Object.keys(params);

    if (method === 'GET' &amp;&amp; paramsKeys.length) {
      const urlObject = new URL(fullURL);
      paramsKeys.forEach((key) => {
        urlObject.searchParams.append(key, params[key]);
      });
      fullURL = urlObject;
    }

    return new Promise((resolve, reject) => {
      fetch(fullURL, requestConfiguration)
        .then((response) => {
          if (response.status >= 400) {
            throw new Error(`Bad response from server: ${response.status}`);
          }

          return response.json();
        })
        .then((result) => {
          return resolve(result);
        })
        .catch((error) => {
          return reject(error);
        });
    });
  }

  /**
   * This function is responsible to make a post to an endpoint after token validation
   *
   * @param {string} url - endpoint uri
   * @param {params} params - Json Object
   * @returns {Promise} Returns a new Promise object.
   */
  post (url, params = {}) {
    return this.sendRequest(url, 'POST', params);
  }

  /**
   * This function is responsible to make a get request to an endpoint after token validation
   *
   * @param {string} url - endpoint uri
   * @param {params} params - Json Object
   * @returns {Promise} Returns a new Promise object.
   */
  get (url, params = {}) {
    return this.sendRequest(url, 'GET', params);
  }

  /**
   * This function is responsible to make a patch request to an endpoint after token validation
   *
   * @param {string} url - endpoint uri
   * @param {params} params - Json Object
   * @returns {Promise} Returns a new Promise object.
   */
  patch (url, params = {}) {
    return this.sendRequest(url, 'PATCH', params);
  }

  /**
   * This function is responsible to make a delete request to an endpoint after token validation
   *
   * @param {string} url - endpoint uri
   * @param {params} params - Json Object
   * @returns {Promise} Returns a new Promise object.
   */
  delete (url, params = {}) {
    return this.sendRequest(url, 'DELETE', params);
  }
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="HttpClient.html">HttpClient</a></li><li><a href="MagentoClient.html">MagentoClient</a></li></ul><h3>Global</h3><ul><li><a href="global.html#addDocuments">addDocuments</a></li><li><a href="global.html#addProduct">addProduct</a></li><li><a href="global.html#addTags">addTags</a></li><li><a href="global.html#Channels-SDK_Example">Channels-SDK_Example</a></li><li><a href="global.html#Countries-SDK_Example">Countries-SDK_Example</a></li><li><a href="global.html#default">default</a></li><li><a href="global.html#Documents-SDK_Example">Documents-SDK_Example</a></li><li><a href="global.html#filter">filter</a></li><li><a href="global.html#generateEndpointsCrudMethods">generateEndpointsCrudMethods</a></li><li><a href="global.html#getProducts">getProducts</a></li><li><a href="global.html#getSalesPerson">getSalesPerson</a></li><li><a href="global.html#getTradeShows">getTradeShows</a></li><li><a href="global.html#importAndExecuteModules">importAndExecuteModules</a></li><li><a href="global.html#ProductCategories-SDK_Example">ProductCategories-SDK_Example</a></li><li><a href="global.html#Products-SDK_Example">Products-SDK_Example</a></li><li><a href="global.html#Recipes-SDK_Example">Recipes-SDK_Example</a></li><li><a href="global.html#removeTags">removeTags</a></li><li><a href="global.html#retrieveRecipes">retrieveRecipes</a></li><li><a href="global.html#SalesPerson-SDK_Example">SalesPerson-SDK_Example</a></li><li><a href="global.html#salesPersonModule">salesPersonModule</a></li><li><a href="global.html#SalesRepresentative-SDK_Example">SalesRepresentative-SDK_Example</a></li><li><a href="global.html#Samples-SDK_Example">Samples-SDK_Example</a></li><li><a href="global.html#setSalesPerson">setSalesPerson</a></li><li><a href="global.html#setTradeShow">setTradeShow</a></li><li><a href="global.html#synchronize">synchronize</a></li><li><a href="global.html#Tags-SDK_Example">Tags-SDK_Example</a></li><li><a href="global.html#Tradeshow-SDK_Example">Tradeshow-SDK_Example</a></li><li><a href="global.html#UserTypes-SDK_Example">UserTypes-SDK_Example</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.3</a> on Fri Nov 22 2019 13:09:48 GMT-0600 (Central Standard Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
